/*
biblioteca de busca
*/

// atualiza as configuracoes
function f_alterar_configuracao(tipo) {
	var pos_inicial;
	// dicionario
	if (tipo == "dicionario") {
		if (document.getElementById("elm_dic_grande").checked == true) { dicionario = "grande"; }
	    else if (document.getElementById("elm_dic_sinant").checked == true) { dicionario = "sinant"; }
        f_post_message(4, "dhserver_dicionario", dicionario);
        f_post_message(5, "dhserver_dicionario", dicionario);
        f_post_message(6, "dicionario", dicionario);
		// foca o campo de digitacao para eventualmente mudar o estilo
		document.getElementById("elm_dhserver_textobusca").focus();
	}
	// tamanho de fonte
	if (tipo == "tamanho_fonte") {
		if (document.getElementById("elm_fonte_pq").checked == true) { tamanho_fonte = "1"; }
	    else if (document.getElementById("elm_fonte_md").checked == true) { tamanho_fonte = "2"; }
		else if (document.getElementById("elm_fonte_gr").checked == true) { tamanho_fonte = "3"; }
        f_post_message(4, "dhserver_tamanho_fonte", tamanho_fonte);
        f_post_message(5, "dhserver_tamanho_fonte", tamanho_fonte);
        f_post_message(6, "tamanho_fonte", tamanho_fonte);
	}
    // duplo clique (obrigatorio se a busca foi desativada)
    if (tipo == "duplo_clique") {
	    // duplo clique
	    if (document.getElementById("elm_duplo_clique").checked == true) {
	        f_post_message(4, "dhserver_duplo_clique", "1");
	        f_post_message(5, "dhserver_duplo_clique", "1");
	    }
	    else {
	        f_post_message(4, "dhserver_duplo_clique", "0");
	        f_post_message(5, "dhserver_duplo_clique", "0");
	    }
	    // alt pressionado
	    if (document.getElementById("elm_alt_obrigatorio").checked == true) {
	        f_post_message(4, "dhserver_alt_obrigatorio", "1");
	        f_post_message(5, "dhserver_alt_obrigatorio", "1");
	    }
	    else {
	        f_post_message(4, "dhserver_alt_obrigatorio", "0");
	        f_post_message(5, "dhserver_alt_obrigatorio", "0");
	    }
	    // ctrl pressionado
	    if (document.getElementById("elm_ctrl_obrigatorio").checked == true) {
	        f_post_message(4, "dhserver_ctrl_obrigatorio", "1");
	        f_post_message(5, "dhserver_ctrl_obrigatorio", "1");
	    }
	    else {
	        f_post_message(4, "dhserver_ctrl_obrigatorio", "0");
	        f_post_message(5, "dhserver_ctrl_obrigatorio", "0");
	    }
	}
    // posicao inicial
    if (tipo == "pos_inicial") {
	    if (document.getElementById("elm_pos_se").checked == true) {
	    	pos_inicial = "se";
	    }
	    else if (document.getElementById("elm_pos_sw").checked == true) {
	    	pos_inicial = "sw";
	    }
	    else if (document.getElementById("elm_pos_nw").checked == true) {
	    	pos_inicial = "nw";
	    }
	    else if (document.getElementById("elm_pos_ne").checked == true) {
	    	pos_inicial = "ne";
	    }
	    f_post_message(4, "dhserver_pos_inicial", pos_inicial);
	    f_post_message(5, "dhserver_pos_inicial", pos_inicial);
	    f_post_message(6, "pos_inicial", pos_inicial);
    }
    // palavras clicaveis
    if (tipo == "verbetes_clicaveis") {
	    if (document.getElementById("elm_verbetes_clicaveis").checked == true) {
	        f_post_message(4, "dhserver_funcoes_html", "1");
	        f_post_message(5, "dhserver_funcoes_html", "1");
	    }
	    else {
	        f_post_message(4, "dhserver_funcoes_html", "2");
	        f_post_message(5, "dhserver_funcoes_html", "2");
	    }
	}
};

// apaga o conteudo atualmente mostrado
function f_apagar_conteudo() {
	document.getElementById("elm_dhserver_divconteudo").innerHTML = "";
	document.getElementById("elm_dhserver_divconteudo").style.display = "none";
}

// apaga o sinal de busca
function f_apagar_sinal_busca() {
	document.getElementById("elm_ajax_loader").innerHTML = "<img src=\"img/h_nav.gif\" height=\"20px\" class=\"noselect\">";
}

// busca um verbete clicado
function f_buscar(palavra, idclick) {
    f_post_message(10, palavra, "");
}

// toma providencias quando o campo de busca e selecionado ou alterado
function f_campo_busca(tipo) {
	// se o campo de busca foi selecionado
	if (tipo == 1) {
		// atualiza a sylesheet
        f_post_message(7, "", "");
	}
	// se o campo de busca foi alterado
	else if (tipo == 2) {
		// faz uma busca por digitacao
        f_post_message(9, document.getElementById('elm_dhserver_textobusca').value, "");
	}
}

// conteudo para configuracao da iframe
function f_configurar() {
    var configuracao;
    // define conteudo
    configuracao = "<div class=\"div_config\">";
    configuracao += "<div class=\"titulo1\" align=\"center\">Configura&ccedil;&otilde;es</div>";
    configuracao += "<p>";
    configuracao += "<input type=\"radio\" id=\"elm_dic_grande\" name=\"dicionario\" onchange=\"f_alterar_configuracao('dicionario')\" value=\"grande\"> L&iacute;ngua Portuguesa ";
    configuracao += "<br><input type=\"radio\" id=\"elm_dic_sinant\" name=\"dicionario\" onchange=\"f_alterar_configuracao('dicionario')\" value=\"sinant\"> Sin&ocirc;nimos e Ant&ocirc;nimos";
    configuracao += "</p>";
    configuracao += "<p>";
    configuracao += "<input id=\"elm_duplo_clique\" type=\"checkbox\" onchange=\"f_alterar_configuracao('duplo_clique')\" value=\"1\"> selecionar ou fazer duplo clique abrem a defini&ccedil;&atilde;o<br>";
    configuracao += "&nbsp;&nbsp;&nbsp;<input id=\"elm_alt_obrigatorio\" type=\"checkbox\" onchange=\"f_alterar_configuracao('duplo_clique')\" value=\"1\"> tamb&eacute;m necess&aacute;rio pressionar alt<br>";
    configuracao += "&nbsp;&nbsp;&nbsp;<input id=\"elm_ctrl_obrigatorio\" type=\"checkbox\" onchange=\"f_alterar_configuracao('duplo_clique')\" value=\"1\"> tamb&eacute;m necess&aacute;rio pressionar ctrl<br>";
    configuracao += "</p>";
    configuracao += "<p>";
    configuracao += "localiza&ccedil;&atilde;o do dicion&aacute;rio na tela<br>";
    configuracao += "&nbsp;&nbsp;&nbsp;<input type=\"radio\" id=\"elm_pos_ne\" name=\"nm_pos_inicial\" onchange=\"f_alterar_configuracao('pos_inicial')\" value=\"ne\"> <b>N.E.</b>&nbsp;&nbsp;&nbsp;";
    configuracao += "<input type=\"radio\" id=\"elm_pos_se\" name=\"nm_pos_inicial\" onchange=\"f_alterar_configuracao('pos_inicial')\" value=\"se\"> <b>S.E.</b>&nbsp;&nbsp;&nbsp;";
    configuracao += "<input type=\"radio\" id=\"elm_pos_sw\" name=\"nm_pos_inicial\" onchange=\"f_alterar_configuracao('pos_inicial')\" value=\"sw\"> <b>S.O.</b>&nbsp;&nbsp;&nbsp;";
    configuracao += "<input type=\"radio\" id=\"elm_pos_nw\" name=\"nm_pos_inicial\" onchange=\"f_alterar_configuracao('pos_inicial')\" value=\"nw\"> <b>N.O.</b>&nbsp;&nbsp;&nbsp;<br>";
    configuracao += "</p>";
    configuracao += "<p>";
    configuracao += "<input id=\"elm_verbetes_clicaveis\" type=\"checkbox\" onchange=\"f_alterar_configuracao('verbetes_clicaveis')\" value=\"1\"> as palavras dos verbetes s&atilde;o clic&aacute;veis";
    configuracao += "</p>";
    configuracao += "</div>";
    // estica iframe e mostra configuracao
    f_post_message(1, configuracao, "");
};

// determina formato do cursor
function f_cursor() {
}

// mostra um conteudo recebido
function f_mostrar_conteudo(conteudo, altura) {
    //console.log("mostro conteudo");
    // determina a altura da div
    document.getElementById("elm_dhserver_divconteudo").style.minHeight = altura + "px";
    document.getElementById("elm_dhserver_divconteudo").style.maxHeight = altura + "px";
    // mostra conteudo
	document.getElementById("elm_dhserver_divconteudo").innerHTML = conteudo;
    document.getElementById("elm_dhserver_divconteudo").style.display = "block";
}


// mostra sinal de busca
function f_mostrar_sinal_busca() {
	document.getElementById("elm_ajax_loader").innerHTML = "<img src=\"img/sbl_cloud_white.png\"  height=\"20px\" class=\"noselect\">";
}

// envia mensagem p container
function f_post_message(tipo, texto1, texto2) {
    var altura;
    // mensagem 1: informa que iframe precisa ser esticada
    // mensagem 2: liga a busca
    // mensagem 3: desliga a busca
    // mensagem 4: altera valor de variavel em memoria
    // mensagem 5: salva variavel em localstorage
    // mensagem 6: altera dados em funcao de nova configuracao
    // mensagem 7: atualizar stylesheet
    // mensagem 8: atualiza a tela com a configuracao atual
    // mensagem 9: busca por digitacao
    // mensagem 10: atualiza a tela com a configuracao atual
    // envia mensagem
    //console.log("envio mensagem p mae:"+ "dhserver<1>" + tipo + "<1>" + texto1 + "<1>" + texto2);
    parent.postMessage("dhserver<1>" +tipo + "<1>" + texto1 + "<1>" + texto2, "*");
}

// recebe mensagem da pagina container
function f_receive_message(event) {
    var ary_partes, mensagem;
    //console.log("recebo mensagem de mae:"+event.data+" de "+event.origin);
    mensagem = event.data;
    ary_partes = mensagem.split("<1>");
    // se a mensagem esta corretamente formatada
    if ((ary_partes.length == 4)&&(ary_partes[0] == "dhserver")) {
        // trocar stylesheet
        if (ary_partes[1] == "stylesheet") {
            if (ary_partes[2] == "sinant") { document.getElementById("elm_stylesheet").href = "estilos_sinant.css?v=1"; }
            else if (ary_partes[2] == "grande") { document.getElementById("elm_stylesheet").href = "estilos_grande.css?v=1"; }
        }
        // trocar atributo checked
        else if (ary_partes[1] == "checked") {
            if (ary_partes[3] == 0) { document.getElementById(ary_partes[2]).checked = false; }
            else if (ary_partes[3] == 1) { document.getElementById(ary_partes[2]).checked = true; }
        }
        // trocar atributo display
        else if (ary_partes[1] == "display") {
            document.getElementById(ary_partes[2]).style.display = ary_partes[3];
        }
        // trocar atributo disabled
        else if (ary_partes[1] == "disabled") {
            if (ary_partes[3] == 0) { document.getElementById(ary_partes[2]).disabled = false; }
            else if (ary_partes[3] == 1) { document.getElementById(ary_partes[2]).disabled = true; }
        }
        // apagar sinal de busca
        else if (ary_partes[1] == "f_apagar_sinal_busca") {
            f_apagar_sinal_busca();
        }
        // mostrar sinal de busca
        else if (ary_partes[1] == "f_mostrar_sinal_busca") {
            f_mostrar_sinal_busca();
        }
        // apagar conteudo
        else if (ary_partes[1] == "f_apagar_conteudo") {
            f_apagar_conteudo();
        }
        // mostrar conteudo
        else if (ary_partes[1] == "f_mostrar_conteudo") {
            f_mostrar_conteudo(ary_partes[2], ary_partes[3]);
        }
    }
}

// quando uma mensagem e recebida (da pagina mae)
window.addEventListener('message', (event) => {
    f_receive_message(event);
});
